function [den,poles] = denfit(den,s,n,d,f) 
%den: denominator, s=jw, n,d: degree of num and den, f: data
m = length(s);
[H,Q] = numfit(den,s,max(n,d));
Qd1 = Q(1:m,1:d+1);
Qd2 = Q(m+1:2*m,1:d+1);
Q = Q(:,1:n+1);
A = [];
for k=1:size(f,2)
    fr=real(f(:,k));
    fi=imag(f(:,k));
    Ar = -[fr.*Qd1-fi.*Qd2;fr.*Qd2+fi.*Qd1];
    Ar = Ar - Q*(Q.'*Ar)/m;
    [~,R] = qr(Ar,0);
    A = [A;R];
end
[~,~,V] = svd(A,0);
c = V(:,end);
poles = eig(H(1:d,1:d) - H(d+1,d)*(1/c(end))*c(1:end-1)*flip(eye(1,d)));
poles(find(real(poles)>0)) = poles(find(real(poles)>0))*-1; %pole flipping
den = 1./(prod((s.'-poles)./mean(abs(s)),1).');





